/*
 * This file is generated by jOOQ.
 */
package de.ship.db.tables;


import de.ship.db.CommonDd;
import de.ship.db.tables.records.VCoreVariableSegmentRecord;

import java.util.Collection;

import org.jooq.Condition;
import org.jooq.Field;
import org.jooq.Name;
import org.jooq.PlainSQL;
import org.jooq.QueryPart;
import org.jooq.SQL;
import org.jooq.Schema;
import org.jooq.Select;
import org.jooq.Stringly;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.TableOptions;
import org.jooq.impl.DSL;
import org.jooq.impl.SQLDataType;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class VCoreVariableSegment extends TableImpl<VCoreVariableSegmentRecord> {

    private static final long serialVersionUID = 1L;

    /**
     * The reference instance of <code>common_dd.v_core_variable_segment</code>
     */
    public static final VCoreVariableSegment V_CORE_VARIABLE_SEGMENT = new VCoreVariableSegment();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<VCoreVariableSegmentRecord> getRecordType() {
        return VCoreVariableSegmentRecord.class;
    }

    /**
     * The column <code>common_dd.v_core_variable_segment.unique_name</code>.
     */
    public final TableField<VCoreVariableSegmentRecord, String> UNIQUE_NAME = createField(DSL.name("unique_name"), SQLDataType.CLOB, this, "");

    /**
     * The column <code>common_dd.v_core_variable_segment.name</code>.
     */
    public final TableField<VCoreVariableSegmentRecord, String> NAME = createField(DSL.name("name"), SQLDataType.CLOB, this, "");

    /**
     * The column <code>common_dd.v_core_variable_segment.tree</code>.
     */
    public final TableField<VCoreVariableSegmentRecord, String> TREE = createField(DSL.name("tree"), SQLDataType.CLOB, this, "");

    private VCoreVariableSegment(Name alias, Table<VCoreVariableSegmentRecord> aliased) {
        this(alias, aliased, (Field<?>[]) null, null);
    }

    private VCoreVariableSegment(Name alias, Table<VCoreVariableSegmentRecord> aliased, Field<?>[] parameters, Condition where) {
        super(alias, null, aliased, parameters, DSL.comment(""), TableOptions.view("""
        create view "v_core_variable_segment" as  SELECT e.unique_name,
         s.name,
         t.tree
        FROM ((common_dd.t_core_variable_segment s
          LEFT JOIN common_dd.t_core_element_hierarchy e ON ((e.key_element = s.fk_element)))
          LEFT JOIN common_dd.v_core_element_tree t ON ((t.key_element = s.fk_element)));
        """), where);
    }

    /**
     * Create an aliased <code>common_dd.v_core_variable_segment</code> table
     * reference
     */
    public VCoreVariableSegment(String alias) {
        this(DSL.name(alias), V_CORE_VARIABLE_SEGMENT);
    }

    /**
     * Create an aliased <code>common_dd.v_core_variable_segment</code> table
     * reference
     */
    public VCoreVariableSegment(Name alias) {
        this(alias, V_CORE_VARIABLE_SEGMENT);
    }

    /**
     * Create a <code>common_dd.v_core_variable_segment</code> table reference
     */
    public VCoreVariableSegment() {
        this(DSL.name("v_core_variable_segment"), null);
    }

    @Override
    public Schema getSchema() {
        return aliased() ? null : CommonDd.COMMON_DD;
    }

    @Override
    public VCoreVariableSegment as(String alias) {
        return new VCoreVariableSegment(DSL.name(alias), this);
    }

    @Override
    public VCoreVariableSegment as(Name alias) {
        return new VCoreVariableSegment(alias, this);
    }

    @Override
    public VCoreVariableSegment as(Table<?> alias) {
        return new VCoreVariableSegment(alias.getQualifiedName(), this);
    }

    /**
     * Rename this table
     */
    @Override
    public VCoreVariableSegment rename(String name) {
        return new VCoreVariableSegment(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public VCoreVariableSegment rename(Name name) {
        return new VCoreVariableSegment(name, null);
    }

    /**
     * Rename this table
     */
    @Override
    public VCoreVariableSegment rename(Table<?> name) {
        return new VCoreVariableSegment(name.getQualifiedName(), null);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreVariableSegment where(Condition condition) {
        return new VCoreVariableSegment(getQualifiedName(), aliased() ? this : null, null, condition);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreVariableSegment where(Collection<? extends Condition> conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreVariableSegment where(Condition... conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreVariableSegment where(Field<Boolean> condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VCoreVariableSegment where(SQL condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VCoreVariableSegment where(@Stringly.SQL String condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VCoreVariableSegment where(@Stringly.SQL String condition, Object... binds) {
        return where(DSL.condition(condition, binds));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VCoreVariableSegment where(@Stringly.SQL String condition, QueryPart... parts) {
        return where(DSL.condition(condition, parts));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreVariableSegment whereExists(Select<?> select) {
        return where(DSL.exists(select));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreVariableSegment whereNotExists(Select<?> select) {
        return where(DSL.notExists(select));
    }
}
